import * as SQS from 'aws-sdk/clients/sqs';
import { Consumer, ConsumerOptions } from 'sqs-consumer';
import { DefaultTaskContext, OperationName, OperationConfiguration } from './types';
export declare function getDefaultTaskContext(sqsMessage: SQS.Message): Promise<DefaultTaskContext>;
export declare type MessageHandlerFn = (message: SQS.Types.Message) => Promise<void>;
export declare function createMessageHandler<TContext>(config: CreateConsumerInput<TContext>): MessageHandlerFn;
export interface CreateConsumerInput<ContextType> {
    queueUrl: string;
    routes: Record<OperationName, OperationConfiguration>;
    getContext(message: SQS.Types.Message): Promise<ContextType>;
    consumerOptions?: ConsumerOptions;
}
export declare function createTaskConsumer<TContext>(config: CreateConsumerInput<TContext>): Consumer;
